﻿using System;
using System.Windows.Forms;
using System.ServiceModel;

using TestClient.ReportService;

namespace TestClient
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form, IReportServiceCallback
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.processReportButton.Click += processReportButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 진행하기 - Progress(percentage)

        /// <summary>
        /// 진행하기
        /// </summary>
        /// <param name="percentage">백분율</param>
        public void Progress(int percentage)
        {
            this.progressTextBox.Text = percentage.ToString() + " % 완료";
        }

        #endregion
        
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 리포트 처리하기 버튼 클릭시 처리하기 - processReportButton_Click(sender, e)

        /// <summary>
        /// 리포트 처리하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void processReportButton_Click(object sender, EventArgs e)
        {
            InstanceContext instanceContext = new InstanceContext(this);

            ReportServiceClient client = new ReportServiceClient(instanceContext, "NetTcpBinding_IReportService");

            client.ProcessReport();            
        }

        #endregion
    }
}